/*
 * RGBledswitch
 * Az SW2 nyomógombbal sorban léptetjük 0 és 7 között az RGB LED színkódjait, melynek
 * értelmezése: 0. bit = piros, 1. bit = zöld 2. bit = kék alapszín.
 * A 0 színkód azt jelenti, hogy kikapcsolva hagyjuk az összes alapszínt (fekete).
 *
 * Hardver követelmények: MSP430 Launchpad kártya, közös katódú RGB LED a 
 * P2_2, P1_6, P2_4 kivezetésekre kötve (áramkorlátozó ellenállásokon keresztül).
 */
#define LED_RED    P2_2
#define LED_BLUE   P2_4
#define LED_GREEN  P1_6

int color = 1;                          //színkód (0..7)
boolean waitforpress = true;

void setup() {                
  // Kimenetként inicialzáljuk a LED vezérlő lábakat
  pinMode(LED_RED, OUTPUT);     
  pinMode(LED_BLUE, OUTPUT);     
  pinMode(LED_GREEN, OUTPUT);     
  pinMode(PUSH2,INPUT_PULLUP);  
}

void loop() {
  if(waitforpress) {             //Ha lenyomásra várunk és
    if(!digitalRead(PUSH2)) {    //Ha lenyomás történt...
      color = ++color & 0x07;    //Szín léptetése
      digitalWrite(LED_RED, color & 1);    // piros LED ki
      digitalWrite(LED_GREEN, color & 2);  // zöld LED ki
      digitalWrite(LED_BLUE, color & 4);   // kék LED ki
      waitforpress = false;      //Következő stáció: felengedésre várunk
    }
  }  
  else {                         //Ha felengedésre vártunk és
    if(digitalRead(PUSH2)) {     //Ha felengedést észlelünk...
      waitforpress = true;       //Következő stáció: lenyomásra várunk
    }
  }  
  delay(20);                    //pergésmentesítő késleltetés  
}


